VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "www.ActiveVB.de - Dateien Verkrzen"
   ClientHeight    =   1770
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6930
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1770
   ScaleWidth      =   6930
   StartUpPosition =   2  'Bildschirmmitte
   Begin VB.CommandButton Command6 
      Caption         =   "Zeichen entfernen VB-Methode"
      Height          =   570
      Left            =   5070
      TabIndex        =   5
      Top             =   975
      Width           =   1695
   End
   Begin VB.CommandButton Command5 
      Caption         =   "Zeichen entfernen API-Methode"
      Height          =   570
      Left            =   5070
      TabIndex        =   4
      Top             =   225
      Width           =   1695
   End
   Begin VB.CommandButton Command4 
      Caption         =   "Unix-Text --> DOS-Text VB-Methode"
      Height          =   600
      Left            =   2550
      TabIndex        =   3
      Top             =   990
      Width           =   2010
   End
   Begin VB.CommandButton Command3 
      Caption         =   "DOS-Text --> Unix-Text VB-Methode"
      Height          =   600
      Left            =   210
      TabIndex        =   2
      Top             =   975
      Width           =   2010
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Unix-Text --> DOS-Text API-Methode"
      Height          =   600
      Left            =   2550
      TabIndex        =   1
      Top             =   210
      Width           =   2010
   End
   Begin VB.CommandButton Command1 
      Caption         =   "DOS-Text --> Unix-Text API-Methode"
      Height          =   600
      Left            =   195
      TabIndex        =   0
      Top             =   195
      Width           =   2010
   End
   Begin VB.Line Line1 
      BorderColor     =   &H00FFFFFF&
      Index           =   1
      X1              =   4860
      X2              =   4860
      Y1              =   210
      Y2              =   1650
   End
   Begin VB.Line Line1 
      BorderColor     =   &H00808080&
      Index           =   0
      X1              =   4845
      X2              =   4845
      Y1              =   195
      Y2              =   1635
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Dieser Source stammt von http://www.activevb.de
' und kann frei verwendet werden. Fr eventuelle Schden
' wird nicht gehaftet.
'
' Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
' Ansonsten viel Spa und Erfolg mit diesem Source !
'
' Autor: K. Langbein Klaus@ActiveVB.de
'
' Beschreibung:
'
' Dateien verkrzen
'
' Manchmal kommt es vor dass das Ergebnis einer Dateibearbeitung zu
' einer Dateilnge fhrt, die krzer ist, als die Lnge des Originals.
' Da VB keine Mglichkeit bietet, eine Datei zu verkrzen, behilft man
' sich meist damit, das Ergebnis in eine neue Datei umzuspeichern, was
' jedoch zeitaufwndig ist. Will man z.B. ein Byte aus einer Binrdatei
' entfernen, so ffnet man blicherweise eine 2. Datei, liest den Bereich
' vor dem zu entfernenden Byte per Get ein, schreibt ihn per Put in die
' 2. Datei, liest dann den Bereich nach dem zu entfernenden Zeichen ein
' und schreibt diesen ebenfalls in die 2. Datei. Anschlieend wird die
' ursprngliche Datei gelscht werden und die neue datei erhlt den Namen
' des Originals.
' Mit Hilfe des API-Befehls SetEndOfFile kann eine Datei jedoch auf eine
' neue Lnge gestutzt werden, d.h. berschssige Bytes knnen  abgeschnitten
' werden, so dass man ausschlielich mit einer Datei arbeiten kann. Dies ist
' insbesondere dann von Vorteil, wenn es sich um sehr groe Dateien handelt.

Option Explicit

Private Const GENERIC_WRITE As Long = &H40000000
Private Const GENERIC_READ As Long = &H80000000
Private Const CREATE_ALWAYS As Long = 2&
Private Const OPEN_ALWAYS As Long = 4&
Private Const INVALID_HANDLE_VALUE As Long = -1&
Private Const FILE_BEGIN As Long = 0&

Private Const FILE_ATTRIBUTE_HIDDEN As Long = &H2&
Private Const FILE_ATTRIBUTE_NORMAL As Long = &H80&
Private Const FILE_ATTRIBUTE_READONLY As Long = &H1&
Private Const FILE_ATTRIBUTE_SYSTEM As Long = &H4&
Private Const FILE_ATTRIBUTE_TEMPORARY As Long = &H100&

Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Private Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" ( _
                         ByVal lpFileName As String, ByVal dwDesiredAccess As Long, _
                         ByVal dwShareMode As Long, ByVal lpSecurityAttributes As Long, _
                         ByVal dwCreationDisposition As Long, _
                         ByVal dwFlagsAndAttributes As Long, _
                         ByVal hTemplateFile As Long) As Long
                         
Private Declare Function SetFilePointer Lib "kernel32" ( _
                         ByVal hFile As Long, ByVal lDistanceToMove As Long, _
                         lpDistanceToMoveHigh As Long, ByVal dwMoveMethod As Long) As Long
                         
Private Declare Function SetEndOfFile Lib "kernel32" (ByVal hFile As Long) As Long

Dim fname As String
Dim l As Long
Private Function DeleteBytesFromFile(ByVal fname As String, _
                                     ByVal PosStart As Long, _
                                     ByVal nBytes As Long) _
                                     As Long
                                     
    Dim Buffer As String
    Dim fno As Long
    Dim lOld As Long
    Dim lNew As Long
    Dim ret As Long
    
    fno = FreeFile
    Open fname For Binary As #fno
    lOld = LOF(fno)
    
    Buffer = Space$(lOld - (PosStart + nBytes) + 1)
    
    Get #fno, PosStart + nBytes, Buffer
    Put #fno, PosStart, Buffer
    Close #fno
    lNew = lOld - nBytes
    ret = TruncateFile(fname, lNew)
    DeleteBytesFromFile = lNew
    
End Function

Function ReplaceInFile(ByVal FileName As String, ByVal OldString As String, _
    ByVal NewString As String) As Long

    Dim Text As String
    Dim fno As Long
    Dim lOld As Long
    Dim lNew As Long
    Dim ret As Long
    
    lOld = FileLen(FileName)
    fno = FreeFile

    Open FileName For Binary As fno
    Text = Space$(lOld)
    
    Get #fno, 1, Text
    Text = Replace(Text, OldString, NewString)
    Put #fno, 1, Text
    lNew = Seek(fno) - 1 ' Neue Lnge berechnen. Der Dateizeiger steht
    Close #fno           ' immer hinter dem bereits beschriebenen Bereich.
    
    If lNew < lOld Then
        ' Wenn die neue Lnge kleiner ist, verkrzen wir die Datei. Sie
        ' mu jedoch vorher geschlossen werden, das sie per API erneut
        ' geffnet wird.
        ret = TruncateFile(FileName, lNew, FILE_ATTRIBUTE_NORMAL, True)
    End If
    ReplaceInFile = FileLen(FileName)

End Function





Function ReplaceInFileVB(ByVal FileName As String, ByVal OldString As String, _
    ByVal NewString As String) As Long

    ' Hier zum Vergleich die VB-Methode. Unter VB gibt es keine
    ' Mglichkeit eine bestehende Datei zu verkrzen.

    Dim Text As String
    Dim fno As Long
    Dim lOld As Long
    Dim lNew As Long
       
    lOld = FileLen(FileName)
    fno = FreeFile
    Open FileName For Binary As fno
    
    Text = Space$(lOld)
    Get #fno, 1, Text
    Text = Replace(Text, OldString, NewString)

    If lNew < lOld Then    ' Wenn die neue Lnge kleiner ist, als die des
        Close #fno         ' Originals, mu man eine neue Datei erzeugen, um
        Kill FileName     ' die Dateilnge zurckzusetzen. Bei sehr groen
        fno = FreeFile     ' Dateien (100 MB) sollte man 2 Dateien offen-
        Open FileName For Binary As fno 'halten, um umzuspeichern.
    End If
    
    Put #fno, 1, Text
    Close #1
    ReplaceInFileVB = FileLen(FileName)

End Function

Private Function TruncateFile(ByVal FileName As String, _
                              ByVal NewLength As Long, _
                              Optional ByVal Attrib As Long _
                              = FILE_ATTRIBUTE_NORMAL, _
                              Optional ByVal RaiseError As Boolean _
                              ) As Long
    
    If RaiseError = False Then ' Wahlweise lsen wir einen Fehler aus
        On Error GoTo err1     ' oder geben nur eine Fehlernr. zurck.
    End If
    
    Dim hFile As Long
    Dim FDate As String
    Dim ret As Long

    ' Wir verwenden FileDatetime um zu berprfen, ob die Datei existiert.
    ' Dies ist gnstiger, als Dir$(), da so auch falsche Pfade einen Fehler
    ' auslsen (was hier erwnscht ist).
    FDate = FileDateTime(FileName)
    
    ' Falls kein Fehler aufgetreten ist, wird die Datei geffnet und wir
    ' erhalten ein Handle.
    hFile = CreateFile(FileName, GENERIC_WRITE Or GENERIC_READ, _
                       0, 0, OPEN_ALWAYS, Attrib, 0)
                       
    'Falls kein Handle zurckgegeben wird, lsen wir einen Fehler aus
    ' und/oder geben eine Fehlernr. zurck.
    If (hFile = 0) Or (hFile = INVALID_HANDLE_VALUE) Then
        ret = -1
        If RaiseError = True Then  ' Falls erwnscht, lsen wir einen Fehler
            Err.Raise 70           ' aus, der in der aufrufenden Funktion so
        End If                     ' behandelt, wird, wie bei einem VB-Fehler
        GoTo exi                   ' blich.
    End If
    
    ' Jetzt wird der Dateizeiger an die gewnschte Stelle geschoben. Dies
    ' entspricht der Seek-Anweisung.
    ret = SetFilePointer(hFile, NewLength, 0, FILE_BEGIN)
    If ret = 0 Then
        ret = -2                ' Falls SetFilePointer erfolglos war,
        Call CloseHandle(hFile) ' machen wir zu und verlassen die
        GoTo exi                ' Funktion.
    End If
    
    ' Per SetEndOfFile wird die Datei an der aktuellen Position
    ' abgeschnitten.
    ret = SetEndOfFile(hFile)
    If ret = 0 Then
        ret = -3                ' falls erfolglos, was unwahrscheinlich,
        Call CloseHandle(hFile) ' ist schlieen und verlassen.
        GoTo exi
    End If
    
    ' Wenn kein Fehler auftrat, schlieen wir das Handle hier.
    ret = CloseHandle(hFile)
    If ret = 0 Then
        ret = -4
    End If
    
exi:
    
    TruncateFile = ret
    Exit Function
    
err1:
    Select Case Err
    
    Case 53
        ret = Err * -1
        Resume exi
    Case 76
        ret = Err * -1
        Resume exi
    Case Else
        'MsgBox err & " " & Error$
    End Select
    
End Function


Private Sub Command1_Click()
    
    On Error GoTo err1
        
    Dim fname As String
    Dim l As Long
    
    ' Als Beispiel fr eine Dateibearbeitung, die zu einer Verringerung
    ' der Lnge fhrt, wandeln wir hier normalen Text, welcher vbCrLf
    ' (Chr$(13) & Chr$(10)) als Zeilentrennzeichen enthlt in das
    ' Unix-Format um, wo ein Zeilenende nur durch ein vbLF (Chr$(10))
    ' markiert wird.
    
    fname = App.Path + "\Beispiel.txt"
    MsgBox "Dateilnge: " & FileLen(fname)
    l = ReplaceInFile(fname, vbCrLf, vbLf)
    MsgBox "Neue Dateilnge: " & l
    Exit Sub
    
err1:
    MsgBox Error
    
End Sub

Private Sub Command2_Click()
    
    Dim fname As String
    Dim l As Long
    
    ' Und das Ganze rckgngig machen:
    
    fname = App.Path + "\Beispiel.txt"
    MsgBox "Dateilnge: " & FileLen(fname)
    l = ReplaceInFile(fname, vbLf, vbCrLf)
    MsgBox "Neue Dateilnge: " & l
    
End Sub

Private Sub Command3_Click()
    
    On Error GoTo err1
        
    Dim fname As String
    Dim l As Long
    
    ' Dies nur zum Vergleich:
    
    fname = App.Path + "\Beispiel.txt"
    MsgBox "Dateilnge: " & FileLen(fname)
    l = ReplaceInFileVB(fname, vbCrLf, vbLf)
    MsgBox "Neue Dateilnge: " & l
    
    Exit Sub
    
err1:
    MsgBox Error
    
End Sub


Private Sub Command4_Click()
    
    fname = App.Path + "\Beispiel.txt"
    MsgBox "Dateilnge: " & FileLen(fname)
    l = ReplaceInFileVB(fname, vbLf, vbCrLf)
    MsgBox "Neue Dateilnge: " & l
    
End Sub

Private Sub Command5_Click()

    ' Als weitere Anwendung der Funktion TruncateFile, bzw.
    ' DeleteBytesFromFile entfernen wir hier ein paar Byte
    ' aus einer Datei.

    Dim fno As Long
    Dim Buffer As String
    Dim pos As Long
    Dim Remove As String

    
    ' Wir suchen zunchst mal nach dem zu entfernenden String:
    Remove = "**********"
    
    fno = FreeFile
    fname = App.Path + "\Beispiel.txt"
    Open fname For Binary As #1
    Buffer = Space$(LOF(fno))
    Get #fno, 1, Buffer
    Close #fno
 
    MsgBox "Dateilnge: " & FileLen(fname)
    
    pos = InStr(Buffer, Remove)
    If pos > 0 Then
        ' Falls der String vorhanden ist, entfernen wir ihn
        l = DeleteBytesFromFile(fname, pos, Len(Remove))
    End If
    MsgBox "Neue Dateilnge: " & FileLen(fname)
    
    
End Sub

Private Sub Command6_Click()
    
    MsgBox "Zur bung selber programmieren :-)", vbInformation
    
End Sub

